/***************************************************************************
 *            PSMSFileDetails.h
 *
 *  
 *  libpsms  - library of Promise SmartStor Media Server
 *
 *  Copyright (C) 2007 Promise Technology Inc.  
 ****************************************************************************/
 
#ifndef _PSMSFILEDETAILS_H
#define _PSMSFILEDETAILS_H

#include <ContentDirectory/ContentDatabase.h>
#include <ContentDirectory/FileDetails.h>
#include <string>
#include <fstream> // add by Steven

class PSMSCFileDetails
{
  protected:
    PSMSCFileDetails();
  
  public:
    static PSMSCFileDetails* Shared();
    OBJECT_TYPE GetObjectType(std::string p_sFileName);
    std::string GetObjectTypeAsString(unsigned int p_nObjectType);
    static std::string GetMimeType(std::string p_sFileName, bool p_bTranscodingMimeType);
  
    SMusicTrack GetMusicTrackDetails(std::string p_sFileName, std::string* p_sResult);
  
  private:
    static PSMSCFileDetails* m_Instance; 
    
};
/* Added By Steven */
struct MediaFileDesc {
    char name[128];
    char path[256];
    char mime[32];
    char type[32];
    char extname[8];
    long size;
    int  vertical;
    int  horizontal;
};
int GetMediaType (MediaFileDesc * m_file);
int GetMpegType  (MediaFileDesc * m_file);
int GetJpegType  (MediaFileDesc * m_file);  
int GetPngType	 (MediaFileDesc * m_file);
#endif
