/***************************************************************************
 *            UUID.cpp
 *
 *  FUPPES - Free UPnP Entertainment Service
 *
 *  Copyright (C) 2005, 2006 Ulrich Völkel <u-voelkel@users.sourceforge.net>
 ****************************************************************************/

/*
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License version 2 as
 *  published by the Free Software Foundation.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Library General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include "UUID.h"
#include "Common.h"

#ifdef WIN32
#include <objbase.h> /* for CoCreateGuid() */
#else

#ifdef HAVE_CONFIG_H
#include "../config.h"
#else
#undef HAVE_UUID_UUID_H
#endif

#ifdef HAVE_UUID_UUID_H
#include <uuid/uuid.h>
#endif
#endif

#ifndef WC_NO_BEST_FIT_CHARS
#define WC_NO_BEST_FIT_CHARS        0x00000400
#endif

#include <iostream>
#include <sstream>
//Add by Tonny Chen
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

using namespace std;
std::string m_sUUIDFileName; //add by Tonny Chen 
#define UUID_LEN 36

std::string GenerateUUID()
{
  stringstream sResult;

  #ifdef WIN32

  /* Generate GUID */
  GUID guid;
  CoCreateGuid(&guid);
  wchar_t szTemp[64];
  
  /* Get UUID as string */
  StringFromGUID2(guid, szTemp, sizeof(szTemp));
  
  /* Convert wide char string to ansi string */
  char szUUID[64];
  int nRet = WideCharToMultiByte(CP_ACP, WC_NO_BEST_FIT_CHARS, szTemp, sizeof(szTemp),
    szUUID, sizeof(szUUID), NULL, NULL);

  /* Set result */
  string sTmp = szUUID;
  /* remove leading and trailing brackets */
  sResult << sTmp.substr(1, sTmp.length() - 2);

  #else  
  
  
  #ifdef HAVE_UUID_UUID_H
  uuid_t uuid;
  char*  szUUID = new char[48];
  stringstream sDirFile;
  int size,regen=0;
  FILE *fp;
  
  sDirFile << getenv("DLNAHOME") << "/"<<".uuid"; //modify by Tonny Chen
  m_sUUIDFileName = sDirFile.str();
  
     fp=fopen(m_sUUIDFileName.c_str(),"r");
 
     if(fp != NULL){
     	   
     	  fgets( szUUID,48, fp);
     	  size=strlen(szUUID);
     	  //cout << strlen(szUUID)<< endl;
    	   if (strlen(szUUID) != UUID_LEN){
     	   		cout << "UUID len error, regen one!" << endl;
     				regen =1;
     	   }
     	   fclose(fp);
      } else{
      	//cout <<"Open uuid file fail!" << endl; 
      	regen = 1;   	
      }	

		
			if(regen){
		  	fp=fopen(m_sUUIDFileName.c_str(),"w+");
		  	if(fp != NULL){
  	   		uuid_generate(uuid);  
  				uuid_unparse(uuid, szUUID);
  				fputs(szUUID,fp);
  				fclose(fp);
  			}
			}
 
  //de1c15b4-0c4d-4121-b357-574bf61863b7

//  cout << szUUID <<endl;
  sResult << szUUID; 
  delete[] szUUID;

  #else
  
  srand(time(0));

  int nRandom;
  stringstream sRandom;

  do {
    nRandom = (rand() % 10000) + 1;
    sRandom << nRandom;
  } while (sRandom.str().length() < 8);

  sResult << sRandom.str().substr(0, 8) << "-aabb-dead-beef-1234eeff0000";  
  
  #endif // HAVE_UUID_UUID_H
  
  #endif
  
  return sResult.str();
}


/* srand(time(0));

  int nRandom;
  stringstream sRandom;

  do {
    nRandom = (rand() % 10000) + 1;
    sRandom << nRandom;
  } while (sRandom.str().length() < 8);

  sResult << sRandom.str().substr(0, 8) << "-aabb-dead-beef-1234eeff0000";*/
